//  disable.cc -- jak zakzat implicitn vytven operac
//
//  peklada C++ automaticky vytv (pokud nen definovn):
//   - implicitn konstruktor (jen kdy nen definovn dn jin konstruktor)
//   - 'copy' konstruktor
//   - opertor piazen
//   - destruktor
//

class A { // bzov tda A
  int i;
  A(A&);  // private deklarace 'copy' konstruktoru => zkaz koprovn
          // kd nemus bt definovn!
  A &operator = (A&);  // tot pro operaci piazen
 public:
  A(int x=0) : i(x) {} // explicitn uvedu konstruktor => zkaz automatickho
                       // vytvoen implicitnho konstruktoru
                       // kdyby byl private, nelo by vytvet objekty
                       // tto tdy ani ddit tuto tdu
};

class B : public A {  // A ddme public...
  // tda me bt i przdn
};

int main() {
  A a;
  //A a2(a);  // nelze! nedostupn operace
  A a3;
  B b;
  //B b2=b;   // nelze! peklada neme vytvoit B(B&)
  B b3;

  //a3 = a;   // nedostupn operace
  //b3 = b;   // peklada neme vytvoit operator = pro tdu B

  return 0;
}
