// p1 -- vodn pklad OOP v C++

#include <iostream>  // cout, cerr -- vstup
#include <cstdlib>   // exit() ze standardn knihovny jazyka C (t stdlib.h)
using namespace std; // pi problmech s pekladaem zkuste zruit

void error(char *msg) {      // hlen chyb
  cerr << "Chyba: " << msg << endl;
  exit(1);
}

// nsleduje definice tdy Interval_1_10 - cel sla od 1 do 10
// protoe nem konstruktor, je chybn -- viz p2
class Interval_1_10 {
  int n;                                    // hodnota sla (private)
 public:
  void SetValue(int x) {                    // metoda pro nastaven hodnoty
    if(x<1 || x>10) error("Mimo rozsah");
    n = x;
  }
  int GetValue() { return n; }              // metoda pro zskn hodnoty
};

int main() {                 // testovn ...
  int i;
  Interval_1_10 x;           // vytvoen objektu x
                             // PROBLM: poten hodnota nedefinovna
                             
  x.SetValue(5);             // nastaven hodnoty objektu x
  i = x.GetValue();          // zskn hodnoty objektu x
  cout << "i=" << i << endl;

  x.SetValue(20);            // zpsob chybu!
}

