// p2 -- doplnn konstruktoru a metody Print

#include <iostream>
#include <cstdlib>
using namespace std;

void error(char *msg) {           // hlen chyb
  cerr << "Chyba: " << msg << endl;
  exit(1);
}

class Interval_1_10 {
  int n;
 public:
  Interval_1_10() { n = 1; }      // konstruktor inicializuje objekt
  void SetValue(int x) {
    if(x<1 || x>10) error("Mimo rozsah");
    n = x;
  }
  int GetValue() { return n; }
  void Print() {                  // metoda pro tisk hodnoty sla
    cout << n << endl;
  }
};

int main() {                 // testovn ...
  Interval_1_10 x;           // vytvoen objektu, inicializace konstruktorem
  Interval_1_10 y;

  x.Print();                 // tisk hodnoty objektu x
  x.SetValue(5);             // nastaven hodnoty objektu x
  y = x;                     // implicitn operator =
  y.Print();                 // tisk nov hodnoty objektu y
}

