
#include <stdio.h>
#include <dlfcn.h>

void *handle;
int (*fun1)(int);
const char *err;

int main() {
    printf("program\n");
    handle = dlopen("./libtest1.so",RTLD_LAZY);
    if(!handle)
        return 1;
    fun1 = dlsym(handle, "fun1"); 
    /* if(!fun1) return 2; */
    err = dlerror();
    if(err) {
        fprintf(stderr, "dlsym: error %s\n", err);
        return 3;
    }

    /* call */
    fun1(5);

    dlclose(handle);
    /**/

    handle = dlopen("./libtest2.so",RTLD_LAZY);
    if(!handle)
        return 1;
    fun1 = dlsym(handle, "fun2"); 
    /* if(!fun1) return 2; */
    err = dlerror();
    if(err) {
        fprintf(stderr, "dlsym: error %s\n", err);
        return 3;
    }

    /* call */
    fun1(5);

    dlclose(handle);


    return 0;
}
